OGRE: Ogre::ComPtr< T > Class Template Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Friends | List of all members
Ogre::ComPtr< T > Class Template Reference
Core » General

`#include <OgreComPtr.h>`

## Classes
struct | SafeBoolHelper

## Public Types
typedef int SafeBoolHelper::* | SafeBoolType
typedef T | Type

## Public Member Functions
| ComPtr () ASSUME_NOEXCEPT
template<typename U >
| ComPtr (ComPtr< U > const &other) ASSUME_NOEXCEPT
| ComPtr (const ComPtr &other) ASSUME_NOEXCEPT
template<typename U >
| ComPtr (U *other) ASSUME_NOEXCEPT
| ~ComPtr () ASSUME_NOEXCEPT
template<typename U >
HRESULT | As (ComPtr< U > *res) const ASSUME_NOEXCEPT
void | Attach (T *other) ASSUME_NOEXCEPT
T * | Detach () ASSUME_NOEXCEPT
T * | Get () const ASSUME_NOEXCEPT
T ** | GetAddressOf () ASSUME_NOEXCEPT
| operator SafeBoolType () const ASSUME_NOEXCEPT
NoAddRefRelease< T > * | operator-> () const ASSUME_NOEXCEPT
ComPtr & | operator= (const ComPtr &other) ASSUME_NOEXCEPT
template<typename U >
ComPtr & | operator= (const ComPtr< U > &other) ASSUME_NOEXCEPT
ComPtr & | operator= (T *other) ASSUME_NOEXCEPT
template<typename U >
ComPtr & | operator= (U *other) ASSUME_NOEXCEPT
T ** | ReleaseAndGetAddressOf () ASSUME_NOEXCEPT
void | Reset () ASSUME_NOEXCEPT
void | Swap (ComPtr &other) ASSUME_NOEXCEPT

## Friends
template<typename U >
class | ComPtr

## Member Typedef Documentation

## ◆ SafeBoolType

template<typename T >

typedef int SafeBoolHelper::* Ogre::ComPtr< T >::SafeBoolType

## ◆ Type

template<typename T >

typedef T Ogre::ComPtr< T >::Type

## Constructor & Destructor Documentation

## ◆ ComPtr() [1/4]

template<typename T >

Ogre::ComPtr< T >::ComPtr | ( |  | ) |
| inline

## ◆ ComPtr() [2/4]

template<typename T >
template<typename U >

Ogre::ComPtr< T >::ComPtr | ( | U * | other | ) |
| inline

## ◆ ComPtr() [3/4]

template<typename T >

Ogre::ComPtr< T >::ComPtr | ( | const ComPtr< T > & | other | ) |
| inline

## ◆ ComPtr() [4/4]

template<typename T >
template<typename U >

Ogre::ComPtr< T >::ComPtr | ( | ComPtr< U > const & | other | ) |
| inline

## ◆ ~ComPtr()

template<typename T >

Ogre::ComPtr< T >::~ComPtr | ( |  | ) |
| inline

## Member Function Documentation

## ◆ As()

template<typename T >
template<typename U >

HRESULT Ogre::ComPtr< T >::As | ( | ComPtr< U > * | res | ) | const
| inline

## ◆ Attach()

template<typename T >

void Ogre::ComPtr< T >::Attach | ( | T * | other | ) |
| inline

## ◆ Detach()

template<typename T >

T* Ogre::ComPtr< T >::Detach | ( |  | ) |
| inline

## ◆ Get()

template<typename T >

T* Ogre::ComPtr< T >::Get | ( |  | ) | const
| inline

Referenced by Ogre::D3D11Device::get(), Ogre::D3D11StagingBuffer::getBufferName(), Ogre::D3D11Device::GetClassLinkage(), Ogre::v1::D3D11HardwareBuffer::getD3DBuffer(), Ogre::D3D11TextureGpu::getDefaultDisplaySrv(), Ogre::D3D11Device::GetDXGIFactory(), Ogre::D3D11Device::GetDXGIFactory2(), Ogre::D3D11TextureGpu::getFinalTextureName(), Ogre::D3D11Device::GetImmediateContext(), Ogre::D3D11Device::GetImmediateContext1(), Ogre::D3D11TextureGpu::getMsaaFramebufferName(), Ogre::D3D11BufferInterfaceBase::getVboName(), Ogre::D3D11DynamicBuffer::getVboName(), and Ogre::D3D11Device::operator->().

## ◆ GetAddressOf()

template<typename T >

T** Ogre::ComPtr< T >::GetAddressOf | ( |  | ) |
| inline

## ◆ operator SafeBoolType()

template<typename T >

Ogre::ComPtr< T >::operator SafeBoolType | ( |  | ) | const
| inline

## ◆ operator->()

template<typename T >

NoAddRefRelease<T>* Ogre::ComPtr< T >::operator-> | ( |  | ) | const
| inline

## ◆ operator=() [1/4]

template<typename T >

ComPtr& Ogre::ComPtr< T >::operator= | ( | const ComPtr< T > & | other | ) |
| inline

## ◆ operator=() [2/4]

template<typename T >
template<typename U >

ComPtr& Ogre::ComPtr< T >::operator= | ( | const ComPtr< U > & | other | ) |
| inline

## ◆ operator=() [3/4]

template<typename T >

ComPtr& Ogre::ComPtr< T >::operator= | ( | T * | other | ) |
| inline

## ◆ operator=() [4/4]

template<typename T >
template<typename U >

ComPtr& Ogre::ComPtr< T >::operator= | ( | U * | other | ) |
| inline

## ◆ ReleaseAndGetAddressOf()

template<typename T >

T** Ogre::ComPtr< T >::ReleaseAndGetAddressOf | ( |  | ) |
| inline

## ◆ Reset()

template<typename T >

void Ogre::ComPtr< T >::Reset | ( |  | ) |
| inline

## ◆ Swap()

template<typename T >

void Ogre::ComPtr< T >::Swap | ( | ComPtr< T > & | other | ) |
| inline

Referenced by Ogre::swap().

## Friends And Related Function Documentation

## ◆ ComPtr

template<typename T >
template<typename U >

friend class ComPtr
| friend

The documentation for this class was generated from the following file:

- OgreComPtr.h